@version 2.13
@warnings
@script channel
@name "ef Static Channel"
@define NAME "ef Static Channel"
@define VERSION 1.01

//VERSION COMPATABILITY
//In 8.5 the script has problems with keys created in negative time via interactive tools for some unknown reason.
//In 9.6 it appears to be fine, so lscript version is set to v2.13. LW8.5 is v2.7. LW9.6 is v2.13.
//It might be alright in LW9.0 and LW9.5.

Channel;		//the oa of the channel.
StaticTime;		//the time were the single key should be placed.
StaticValue;	//the value of the single key, should be different depending on channel (scale=1).
StaticKey;		//the current static key.

create: co
{
	Channel = co;

	StaticTime = 0; //Scene().currenttime;
	StaticValue = 0;
	StaticKey = nil;
	
	(StaticKey, StaticValue) = MaintainStaticChannel(Channel, StaticKey, StaticTime, StaticValue);
}

destroy
{
    // take care of final clean-up activities here
}

process: ca, frame, time
{
	(StaticKey, StaticValue) = MaintainStaticChannel(Channel, StaticKey, StaticTime, StaticValue);
}

//function that maintains a single key for a channel
//effectivly making it static.
//schannel	the channel to be processed.
//stime		the prefered time for the single key.
//svalue	the prefered value. could be overriden by internal rules.
//returns 	the new/current static key and it's value.
MaintainStaticChannel: schannel, skey, stime, svalue {
	//establish skey.
	if(!skey) {
		skey = schannel.keyExists(stime); //try to get it.
		if(!skey) //if its not there,
			skey = schannel.createKey(stime, svalue); //create it!
	}
	//maintain skey
	keycount = schannel.keyCount;
	if(keycount==0) {
		skey = schannel.createKey(stime, svalue); //if single key is deleted, it is restored!
	}
	else if(keycount==1) {
		key = schannel.keys[1];
		time = schannel.getKeyTime(key);
		if(time!=stime) {
			svalue = schannel.getKeyValue(key);
			schannel.deleteKey(key);
			skey = schannel.createKey(stime, svalue);
		}
		else
			skey = key;
	}
	else if(keycount>1) {
		key = schannel.keys[keycount]; //highest key
		if(key == skey) key = schannel.keys[1]; //lowest key, ie negative
		svalue = schannel.getKeyValue(key);
		for(i=1, k=1; i<=keycount; i++) {
			key = schannel.keys[k]; //as keys are deleted the count decreases. so this keeps deleting new first key.
			if(key != skey) {
				schannel.deleteKey(key);
			}
			else {
				k=2; //skips over the skey, only happens once.
			}
		}
		schannel.setKeyValue(skey, svalue); //set value of skey to same as assumed newest key (that was deleted)
	}
	
	return(skey, svalue);
}

load: what,io
{
    if(what == SCENEMODE)
    {
    }
}

save: what,io
{
    if(what == SCENEMODE)
    {
    }
}

options
{
//could possibly make the time for the single key configurable.
}